/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  MECCA include file                                                     *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#define DLE 16
#define PATHDELIM ".\\/"
#define TOKENDELIM " \t\n"
#define MAX_TOKENLEN 2000
#define MAX_OFFSETS 150
#define MAX_SYMBOLLEN 64
#define INOUT_BUFFER 8192
#define MAX_LLEN 100

#define LESS -1
#define EQUAL 0
#define MORE 1
#define MAX_SYM 1000

#define Compress_Sequence()                                   \
    {                                                         \
      if (lastch != -1)                                       \
      {                                                       \
        if (lastcount <= 2)                                   \
        {                                                     \
          for (x=0;x <= lastcount;x++)                        \
            putc(lastch,outfile);                             \
        }                                                     \
        else if (lastcount+1==26 || lastcount+1==10 || lastcount+1==13) \
          fprintf(outfile,"%c\x19%c%c",lastch,lastch,lastcount); \
        else fprintf(outfile,"\x19%c%c",lastch,lastcount+1);  \
                                                              \
        lastcount=0;                                          \
        lastch=-1;                                            \
      }                                                       \
                                                              \
      if (lastch != -1)                                       \
        putc(lastch,outfile);                                 \
                                                              \
      lastch=ch;                                              \
    }


/* Structure to hold symbol locations, and real offsets.  Internal to
   Compile()...                                                       */

struct _symbol
{
  char name[MAX_SYMBOLLEN];
  long location;
  long offset[MAX_OFFSETS];
  int offsetnum;
};


/* Structure for verb table, below */
struct _table
{
  char *verb;
  int verbno;
  int colour;
  char *translation;
  void (pascal *fptr)(struct _inf *inf);
};

struct _inf
{
  char **p,
       *outname;
     
  int verbnum;
     
  FILE **outfile,
       *infile;
};


void NoMem(void);
void Parse_Args(int argc,char *argv[]);
void pascal Compile(char *inname,char *outname,int mode,int time_comp);
int sssearch(char *key,struct _table base[],unsigned int num);
void Init_Table(void);
int pascal GEdate(union stamp_combo *s1,union stamp_combo *s2);
int Colour_Num(char *name);
void Put_Colour(FILE *outfile,int col);
int isdigitstr(char *s);
void pascal Invert_Logical(int *verbnum);
int pascal IsValidTimeVerb(int verbnum);
int Determine_Type(char *s);
void pascal Output_Code(int verbnum,FILE *outfile,int *lcol);
void pascal Process_Label(char *p,int define,FILE *outfile);
void pascal Parse_Token(char *outname,FILE **outfile);

void pascal P_Comment (struct _inf *inf);
void pascal P_Copy    (struct _inf *inf);
void pascal P_Include (struct _inf *inf);
void pascal P_On      (struct _inf *inf);
void pascal P_Save    (struct _inf *inf);
void pascal P_Load    (struct _inf *inf);
void pascal P_Fg      (struct _inf *inf);
void pascal P_Bg      (struct _inf *inf);
void pascal P_Steady  (struct _inf *inf);
void pascal P_Dim     (struct _inf *inf);
void pascal P_Bright  (struct _inf *inf);
void pascal P_Priv    (struct _inf *inf);
void pascal P_Label   (struct _inf *inf);
void pascal P_Restore (struct _inf *inf);
void pascal P_Setpriv (struct _inf *inf);
void pascal P_Iftime  (struct _inf *inf);
void pascal P_Repeat  (struct _inf *inf);
void pascal P_Repeatseq(struct _inf *inf);
void pascal P_Goto    (struct _inf *inf);
void pascal P_Locate  (struct _inf *inf);
void pascal P_Menu_Cmd(struct _inf *inf);
 
#define NUM_NUMS 13   /* Number of numbered items */

#ifdef INITIALIZE

struct _table verbs[]=
{

  /* Sorted table of MECCA verbs.  After editing to add a new verb, just   *
   * run QSORT.EXE over the table, and recompile.                          */

  #include "mecca_vb.h"
  
  {"ZZZZZZZZZZ",       0,   -1, "",                 NULL}
};

int verb_table_size=(sizeof(verbs)/sizeof(verbs[0]));

int num_gt,num_lt,num_eq,num_ne,num_ge,num_le,num_above,num_below,num_equal,
    num_unequal,num_notequal,num_ae,num_be;

#else /* !INITIALIZE */

extern struct _table verbs[];

extern int verb_table_size;

extern int num_gt,num_lt,num_eq,num_ne,num_ge,num_le,num_above,num_below,
           num_equal,num_unequal,num_notequal,num_ae,num_be;

#endif

